/*********************************************************************************************************
* Software License Agreement (BSD License)                                                               *
* Author: Sebastien Decugis <sdecugis@nict.go.jp>							 *
*													 *
* Copyright (c) 2008, WIDE Project and NICT								 *
* All rights reserved.											 *
* 													 *
* Redistribution and use of this software in source and binary forms, with or without modification, are  *
* permitted provided that the following conditions are met:						 *
* 													 *
* * Redistributions of source code must retain the above 						 *
*   copyright notice, this list of conditions and the 							 *
*   following disclaimer.										 *
*    													 *
* * Redistributions in binary form must reproduce the above 						 *
*   copyright notice, this list of conditions and the 							 *
*   following disclaimer in the documentation and/or other						 *
*   materials provided with the distribution.								 *
* 													 *
* * Neither the name of the WIDE Project or NICT nor the 						 *
*   names of its contributors may be used to endorse or 						 *
*   promote products derived from this software without 						 *
*   specific prior written permission of WIDE Project and 						 *
*   NICT.												 *
* 													 *
* THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED *
* WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A *
* PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR *
* ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT 	 *
* LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS 	 *
* INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR *
* TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF   *
* ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.								 *
*********************************************************************************************************/

/* Session module.
 * 
 * See session.h and session-api.h for more information on the functions and types involved.
 */

#include <errno.h>

#include "waaad-internal.h"

/* Initialize the module */
int sess_init ( void )
{
	TRACE_ENTRY( "" );
	TRACE_DEBUG (INFO, "@@@ Not implemented yet." );
	return 0;
}

/* End of the module */
int sess_fini ( void )
{
	TRACE_ENTRY( "" );
	TRACE_DEBUG (INFO, "@@@ Not implemented yet." );
	return 0;
}

/* Create a new session (identifier and object). */
int sess_new ( sess_id_t ** session, sess_flags_t flags, char * opt )
{
	TRACE_ENTRY( "%p %d %p", session, flags, opt );
	TRACE_DEBUG (INFO, "@@@ %s: not implemented yet.", __FUNCTION__ );
	return ENOTSUP;
}

/* Find a session object corresponding to a given session-id */
int sess_fromsid ( char * sid, size_t len, sess_id_t ** session)
{
	TRACE_ENTRY( "%p %d %p", sid, len, session );
	TRACE_DEBUG (INFO, "@@@ %s: not implemented yet.", __FUNCTION__ );
	return ENOTSUP;
}

/* Get the session-id string of a session */
int sess_getsid ( sess_id_t * session, char ** sid )
{
	TRACE_ENTRY( "%p %p", session, sid );
	TRACE_DEBUG (INFO, "@@@ %s: not implemented yet.", __FUNCTION__ );
	return ENOTSUP;
}

/* Increase refcount of a session */
int sess_link ( sess_id_t * session )
{
	TRACE_ENTRY( "%p", session );
	TRACE_DEBUG (INFO, "@@@ %s: not implemented yet.", __FUNCTION__ );
	return ENOTSUP;
}

/* Decrease refcount of a session, eventually free it. */
int sess_unlink ( sess_id_t ** session )
{
	TRACE_ENTRY( "%p", session );
	TRACE_DEBUG (INFO, "@@@ %s: not implemented yet.", __FUNCTION__ );
	return ENOTSUP;
}

/* Create a new client of the module. */
int sess_regext ( sess_reg_t ** client )
{
	TRACE_ENTRY( "%p", client );
	TRACE_DEBUG (INFO, "@@@ %s: not implemented yet.", __FUNCTION__ );
	return ENOTSUP;
}

/* Destroy a client of the module. */
int sess_deregext ( sess_reg_t * client )
{
	TRACE_ENTRY( "%p", client );
	TRACE_DEBUG (INFO, "@@@ %s: not implemented yet.", __FUNCTION__ );
	return ENOTSUP;
}

/* Register data in a session. */
int sess_data_reg ( sess_id_t * session, sess_reg_t * client, void * data, void (*cleanup)(void *) )
{
	TRACE_ENTRY( "%p %p %p %p", session, client, data, cleanup );
	TRACE_DEBUG (INFO, "@@@ %s: not implemented yet.", __FUNCTION__ );
	return ENOTSUP;
}

/* Retrieve registered data. */
int sess_data_get ( sess_id_t * session, sess_reg_t * client, void ** data )
{
	TRACE_ENTRY( "%p %p %p", session, client, data );
	TRACE_DEBUG (INFO, "@@@ %s: not implemented yet.", __FUNCTION__ );
	return ENOTSUP;
}

/* Remove registered data from a session. */
int sess_data_dereg ( sess_id_t * session, sess_reg_t * client, void ** data )
{
	TRACE_ENTRY( "%p %p %p", session, client, data );
	TRACE_DEBUG (INFO, "@@@ %s: not implemented yet.", __FUNCTION__ );
	return ENOTSUP;
}

